//----------------------------------------------------------------------//
// H2Tconv																//
//	CtH[														//
//----------------------------------------------------------------------//
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <ShellAPI.hpp>
#include <Buttons.hpp>
#include <Graphics.hpp>
#include <ActnList.hpp>
#include <Clipbrd.hpp>
#include <inifiles.hpp>

#include "htmconv.h"

//---------------------------------------------------------------------------
#define VERSION_NO	91			//o[Wԍ (*100)

#define SUPPORT_URL	"http://nekomimi.la.coocan.jp/"


// o͐(DestMode)
#define DSTMOD_CLIPBD  0	//Nbv{[h/
#define DSTMOD_ORGDIR  1	//Ɠ
#define DSTMOD_SELDIR  2	//ꏊw


//---------------------------------------------------------------------------
class TH2TconvForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TAction *ConvertAction;
	TActionList *ActionList1;
	TBitBtn *ConvBtn;
	TBitBtn *ConvBtnC;
	TButton *AddBtn;
	TButton *ClrBtn;
	TButton *DelBtn;
	TButton *DowItemBtn;
	TButton *InputBtn;
	TButton *PasteBtn;
	TButton *RefAppBtn;
	TButton *RefDstBtn;
	TButton *RefMac1Btn;
	TButton *RefMac2Btn;
	TButton *RefSndBtn;
	TButton *SortBtn;
	TButton *UpItemBtn;
	TCheckBox *AddNoCheck;
	TCheckBox *AltCheck;
	TCheckBox *DropSubCheck;
	TCheckBox *ExtLnkCheck;
	TCheckBox *FrcCrCheck;
	TCheckBox *ImgSrcCheck;
	TCheckBox *InsFtCheck;
	TCheckBox *InsHdCheck;
	TCheckBox *JoinCheck;
	TCheckBox *KillCheck;
	TCheckBox *LinkCheck;
	TCheckBox *LinkCrCheck;
	TCheckBox *OpenAppCheck;
	TCheckBox *PstHdrCheck;
	TCheckBox *SureKillCheck;
	TCheckBox *Tit2NamCheck;
	TCheckBox *TitCvExChCheck;
	TCheckBox *TitCvSpcCheck;
	TCheckBox *TopMostCheck;
	TCheckBox *UseTrashCheck;
	TCheckBox *ZenNoCheck;
	TComboBox *CmpPosCombo;
	TEdit *AltBraEdit;
	TEdit *AltKetEdit;
	TEdit *AppNameEdit;
	TEdit *BlkLmtEdit;
	TEdit *B_BraEdit;
	TEdit *B_KetEdit;
	TEdit *CelSepEdit;
	TEdit *DefAltEdit;
	TEdit *DstDirEdit;
	TEdit *EndSoundEdit;
	TEdit *FilNamEdit;
	TEdit *H1Edit;
	TEdit *H2Edit;
	TEdit *H3Edit;
	TEdit *H4Edit;
	TEdit *H5Edit;
	TEdit *H6Edit;
	TEdit *HrStrEdit;
	TEdit *IndentEdit;
	TEdit *I_BraEdit;
	TEdit *I_KetEdit;
	TEdit *LnkBraEdit;
	TEdit *LnkKetEdit;
	TEdit *LnWidEdit;
	TEdit *MarkEdit;
	TEdit *TitLmtEdit;
	TEdit *U_BraEdit;
	TEdit *U_KetEdit;
	TGroupBox *GrpBox1_1;
	TGroupBox *GrpBox1_2;
	TGroupBox *GrpBox1_3;
	TGroupBox *GrpBox2_10;
	TGroupBox *GrpBox2_1;
	TGroupBox *GrpBox2_2;
	TGroupBox *GrpBox2_3;
	TGroupBox *GrpBox2_4;
	TGroupBox *GrpBox2_5;
	TGroupBox *GrpBox2_6;
	TGroupBox *GrpBox2_7;
	TGroupBox *GrpBox2_8;
	TGroupBox *GrpBox2_9;
	TGroupBox *GrpBox3_1;
	TGroupBox *GrpBox3_2;
	TImage *ArrowImg;
	TLabel *Label10;
	TLabel *Label11;
	TLabel *Label12;
	TLabel *Label13;
	TLabel *Label14;
	TLabel *Label15;
	TLabel *Label16;
	TLabel *Label17;
	TLabel *Label18;
	TLabel *Label19;
	TLabel *Label1;
	TLabel *Label20;
	TLabel *Label21;
	TLabel *Label22;
	TLabel *Label2;
	TLabel *Label3;
	TLabel *Label4;
	TLabel *Label5;
	TLabel *Label6;
	TLabel *Label7;
	TLabel *Label8;
	TLabel *Label9;
	TListBox *HtmFileList;
	TMemo *FootMemo;
	TMemo *HeadMemo;
	TMenuItem *AbautInf1Item;
	TMenuItem *AboutInf2Item;
	TMenuItem *AboutItem;
	TMenuItem *DefaultIniItem;
	TMenuItem *GoWebItem;
	TMenuItem *HelpItem;
	TMenuItem *LoadIniItem;
	TMenuItem *N1;
	TMenuItem *N2;
	TMenuItem *PopDatTimItem;
	TMenuItem *PopDescItem;
	TMenuItem *PopFnameItem;
	TMenuItem *PopFtimeItem;
	TMenuItem *PopKeywdItem;
	TMenuItem *PopLine1Item;
	TMenuItem *PopLine2Item;
	TMenuItem *PopLine3Item;
	TMenuItem *PopTitleItem;
	TMenuItem *SaveIniItem;
	TMenuItem *Sep_m_1;
	TMenuItem *Sep_m_2;
	TOpenDialog *OpenDialog1;
	TPageControl *PageControl1;
	TPanel *CmpBtnPanel;
	TPanel *Panel1_1;
	TPanel *Panel1_1a;
	TPanel *Panel1_1b;
	TPanel *Panel1_2;
	TPanel *Panel2;
	TPanel *Panel3;
	TPopupMenu *PopupMenu1;
	TPopupMenu *ToolMenu;
	TRadioButton *ClipRadioBtn;
	TRadioButton *SamDirRadioBtn;
	TRadioButton *SetDirRadioBtn;
	TSaveDialog *SaveDialog1;
	TSpeedButton *CompactBtn;
	TSpeedButton *MenuBtn;
	TStatusBar *StatusBar1;
	TTabSheet *TabSheet1;
	TTabSheet *TabSheet2;
	TTabSheet *TabSheet3;
	TTabSheet *TabSheet4;
	TUpDown *BlkLmtUpDown;
	TUpDown *LnWidUpDown;
	TUpDown *TitLmtUpDown;

	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall CompactBtnClick(TObject *Sender);
	void __fastcall ConvertExecute(TObject *Sender);
	void __fastcall AddBtnClick(TObject *Sender);
	void __fastcall InputBtnClick(TObject *Sender);
	void __fastcall PasteBtnClick(TObject *Sender);
	void __fastcall DelBtnClick(TObject *Sender);
	void __fastcall ClrBtnClick(TObject *Sender);
	void __fastcall SortBtnClick(TObject *Sender);
	void __fastcall UpItemBtnClick(TObject *Sender);
	void __fastcall DowItemBtnClick(TObject *Sender);
	void __fastcall HtmFileListKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall RefAppBtnClick(TObject *Sender);
	void __fastcall LnWidEditChange(TObject *Sender);
	void __fastcall AltCheckClick(TObject *Sender);
	void __fastcall LinkCheckClick(TObject *Sender);
	void __fastcall BlkLmtEditChange(TObject *Sender);
	void __fastcall RefDstBtnClick(TObject *Sender);
	void __fastcall DestRadioBtnClick(TObject *Sender);
	void __fastcall JoinCheckClick(TObject *Sender);
	void __fastcall HtmFileListClick(TObject *Sender);
	void __fastcall FilNamEditChange(TObject *Sender);
	void __fastcall RefMac1BtnClick(TObject *Sender);
	void __fastcall PopRefItemClick(TObject *Sender);
	void __fastcall RefSndBtnClick(TObject *Sender);
	void __fastcall TopMostCheckClick(TObject *Sender);
	void __fastcall UrlLabelClick(TObject *Sender);
	void __fastcall ConvertActionUpdate(TObject *Sender);
	void __fastcall Tit2NamCheckClick(TObject *Sender);
	void __fastcall NumberEditExit(TObject *Sender);
	void __fastcall TitLmtEditChange(TObject *Sender);
	void __fastcall MenuBtnClick(TObject *Sender);
	void __fastcall LoadIniItemClick(TObject *Sender);
	void __fastcall SaveIniItemClick(TObject *Sender);
	void __fastcall DefaultIniItemClick(TObject *Sender);
	void __fastcall HelpItemClick(TObject *Sender);
	void __fastcall AbautInfItemDrawItem(TObject *Sender, TCanvas *ACanvas,
          TRect &ARect, bool Selected);
	void __fastcall GoWebItemClick(TObject *Sender);
	void __fastcall AbautMeasureItem(TObject *Sender, TCanvas *ACanvas,
          int &Width, int &Height);

private:	// [U[錾
	AnsiString LastDir;		//QƃfBNg
	AnsiString OrgDir;		//ϊ̃fBNg
	AnsiString LastIniDir;	//ݒfBNg

	int  DestMode;			//o͐

	int  PopTag;
	bool Compact;
	bool ConvReady;
	bool Converting;

	bool AutoStart;

	HtmConv *HC;

	void __fastcall WMDropFiles(TWMDropFiles &Msg);
	void __fastcall WMMove(TMessage &Msg);
	void __fastcall AddStrToList(AnsiString s);
	AnsiString __fastcall UrlToName(AnsiString s);
	AnsiString __fastcall TitToName(AnsiString s);
	AnsiString __fastcall AddSerNo(AnsiString s);
	void __fastcall UpdateInf(bool chgf);
	void __fastcall SetFrmStyle();
	void __fastcall LoadIniFile(AnsiString fnam = EmptyStr);
	void __fastcall SaveIniFile(AnsiString fnam = EmptyStr);

public:		// [U[錾
	TIniFile  *IniFile; 		//INIt@C

	__fastcall TH2TconvForm(TComponent* Owner);

	BEGIN_MESSAGE_MAP
		VCL_MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WMDropFiles)
		VCL_MESSAGE_HANDLER(WM_MOVE,	  TMessage,		WMMove)
	END_MESSAGE_MAP(TForm);
};
//---------------------------------------------------------------------------
extern PACKAGE TH2TconvForm *H2TconvForm;
//---------------------------------------------------------------------------
#endif
