//----------------------------------------------------------------------//
//	ėpʊ֐														//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include <mbstring.h>
#include <algorith.h>

#include "UserFunc.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
//召ʂɕ (2oCgΉ)
//  wd: 
//   s: Ώە
//---------------------------------------------------------------------------
int ansi_pos_i(AnsiString wd, AnsiString s)
{
	if (wd.IsEmpty()) return 0;
	int wlen = wd.Length();
	AnsiString w0 = wd.IsLeadByte(1) ? wd.SubString(1,2) : wd.SubString(1,1);
	AnsiString ss = s;
	int p0 = 0;
	for (;;) {
		int pL = ss.AnsiPos(AnsiLowerCase(w0));
		int pU = ss.AnsiPos(AnsiUpperCase(w0));
		int p = (pL==0) ? pU : ((pU==0)? pL : std::min(pL,pU));
		if (p==0) break;
		if (ss.SubString(p, wlen).AnsiCompareIC(wd)==0)
			return p0+p;
		else {
			ss.Delete(1,p);
			p0 += p;
		}
	}
	return 0;
}

//---------------------------------------------------------------------------
//̎w蕶u
//  src  ostr  nstr ɒu
//---------------------------------------------------------------------------
AnsiString replace_str(AnsiString src, AnsiString ostr, AnsiString nstr)
{
	if ((src.IsEmpty())||(ostr.IsEmpty())) return src;
	int p;
	int p0 = 1;	//ʒu
	do {
		AnsiString tmpstr = src.SubString(p0, src.Length()-p0+1);
		p = tmpstr.AnsiPos(ostr);
		if (p>0) {
			int p1 = p0+p-1;	//ł̈ʒu
			src.Delete(p1, ostr.Length());
			src.Insert(nstr, p1);
			p0 = p1 + nstr.Length();	//ʒuXV
		}
	} while (p!=0);
	return src;
}

//---------------------------------------------------------------------------
//ppSpɕϊ
//---------------------------------------------------------------------------
AnsiString to_zenstr(AnsiString src)
{
	char *sbuf = new char[src.Length()*2+1];
	char *p = sbuf;
	for (int i=1;i<=src.Length();i++) {
		if (StrByteType(src.c_str(), i-1) == mbSingleByte) {
			unsigned int c = _mbbtombc((unsigned int)src[i]);
			*p = (char)(c >> 8); p++;
			*p = (char)(c & 0xff); p++;
		} else {
			*p = src[i]; p++;
		}
	}
	*p = '\0';
	AnsiString retstr = sbuf;
	delete [] sbuf;
	return retstr;
}

//---------------------------------------------------------------------------
// a`z ɂ\Lɕϊ
// a`z, aa`az, ba`bz...
//---------------------------------------------------------------------------
AnsiString int_to_alpha(int n)
{
	AnsiString retstr = EmptyStr;
	n--;
	if (n<0)
		retstr = "0";
	else {
		int n1 = n /26;
		if (n1>0) retstr += AnsiString::StringOfChar((char)('a'+n1-1), 1);
		retstr += AnsiString::StringOfChar((char)('a'+(n % 26)), 1);
	}
	return retstr;
}

//---------------------------------------------------------------------------
//(1`999)[}()ɕϊ
//---------------------------------------------------------------------------
AnsiString int_to_roman(int n)
{
	AnsiString retstr = EmptyStr;
	//100̈
	int rn = (n/100)%10;
	if (rn>0) {
		switch (rn) {
		case 1: case 2: case 3:
			retstr += AnsiString::StringOfChar('c', rn); break;
		case 4: retstr += "cd"; break;
		case 5: retstr += "d";  break;
		case 6: case 7: case 8:
			retstr += ("d" + AnsiString::StringOfChar('c', rn-5)); break;
		case 9: retstr += "cm"; break;
		}
	}

	//10̈
	rn = (n/10)%10;
	if (rn>0) {
		switch (rn) {
		case 1: case 2: case 3:
			retstr += AnsiString::StringOfChar('x', rn); break;
		case 4: retstr += "xl"; break;
		case 5: retstr += "l";  break;
		case 6: case 7: case 8:
			retstr += ("l" + AnsiString::StringOfChar('x', rn-5)); break;
		case 9: retstr += "xc"; break;
		}
	}

	//1̈
	rn = n%10;
	switch (rn) {
	case 1: case 2: case 3:
		retstr += AnsiString::StringOfChar('i', rn); break;
	case 4: retstr += "iv"; break;
	case 5: retstr += "v";  break;
	case 6: case 7: case 8:
		retstr += ("v" + AnsiString::StringOfChar('i', rn-5)); break;
	case 9: retstr += "ix"; break;
	}
	return retstr;
}

//---------------------------------------------------------------------------
//GXP[vɖ߂
//---------------------------------------------------------------------------
AnsiString esc_to_str(AnsiString src)
{
	src = replace_str(src,"\\s",	" ");
	src = replace_str(src,"\\t",	"\t");
	src = replace_str(src,"\\n",	"\n");
	src = replace_str(src,"\\r",	"\r");
	src = replace_str(src,"\\\"",	"\"");
	return src;
}
//---------------------------------------------------------------------------
//ꕶGXP[vɕϊ
//---------------------------------------------------------------------------
AnsiString str_to_esc(AnsiString src)
{
	src = replace_str(src," ",	"\\s");
	src = replace_str(src,"\t",	"\\t");
	src = replace_str(src,"\n",	"\\n");
	src = replace_str(src,"\r",	"\\r");
	src = replace_str(src,"\"",	"\\\"");
	return src;
}

//---------------------------------------------------------------------------
//SpXy[Xlg~O
//---------------------------------------------------------------------------
AnsiString trim_ex(AnsiString src) {
	for (;;) {
		if (src.IsEmpty()) break;
		if (src.AnsiPos("@")==1) {
			src.Delete(1,2); continue;
		}
		if ((src[1]==' ')||(src[1]=='\t')) {
			src.Delete(1,1); continue;
		}
		break;
	}
	for (;;) {
		if (src.IsEmpty()) break;
		int n = src.Length();
		if (n>1) {
			if (src.SubString(n-1,2)=="@") {
				src.Delete(n-1,2); continue;
			}
		}
		if ((src[n]==' ')||(src[n]=='\t')) {
			src.Delete(n,1); continue;
		}
		break;
	}
	return src;
}

//---------------------------------------------------------------------------
// " ݂̈͂O
//---------------------------------------------------------------------------
AnsiString del_quot(AnsiString s)
{
	if (!s.IsEmpty()) {
		if ((s[1]=='\"') && (s.SubString(s.Length(),1)=="\""))
			s = s.SubString(2, s.Length()-2);
	}
	return s;
}

//---------------------------------------------------------------------------
//fBNg̃}XNɊYSt@C擾
//  pnam: fBNg
//  mask: }XN
//   lst: ʂi[ TStrings
// subsw: TufBNg
//---------------------------------------------------------------------------
void get_all_files(AnsiString pnam, AnsiString mask, TStrings *lst, bool subsw)
{
	if (pnam.IsEmpty()) return;
	if (mask.IsEmpty()) mask = "*.*";
	if (pnam[pnam.Length()]!='\\') pnam += "\\";

    WIN32_FIND_DATA fd;
	HANDLE hFind;
	AnsiString tmpstr;

	//TufBNg
    if (subsw) {
		tmpstr = pnam+"*";
		hFind  = FindFirstFile(tmpstr.c_str(), &fd);
		if (hFind != INVALID_HANDLE_VALUE ) {
			do {
				if (((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0)
					&& (strcmp(fd.cFileName,"..") != 0)
					&& (strcmp(fd.cFileName,".")  != 0))
				{
					get_all_files(pnam+fd.cFileName, mask, lst, subsw);
				}
			} while(FindNextFile(hFind, &fd));
			FindClose(hFind);
		}
	}

	//t@C
	tmpstr = pnam+mask;
    hFind  = FindFirstFile(tmpstr.c_str(), &fd);
	if (hFind != INVALID_HANDLE_VALUE ) {
		do {
			if ((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)==0) {
				tmpstr = pnam+fd.cFileName;
				if (lst->IndexOf(tmpstr)==-1) lst->Add(tmpstr);
			}
		} while(FindNextFile(hFind, &fd));
		FindClose(hFind);
	}
}

//---------------------------------------------------------------------------
AnsiString get_local_name(AnsiString s)
{
	AnsiString fnam = s;
	if (fnam.AnsiPos("file:///")==1) {
		fnam.Delete(1,8);
		fnam = replace_str(fnam, "/", "\\");
		int p = fnam.AnsiPos("#");
		if (p>0) fnam = fnam.SubString(1,p-1);
	} else {
		fnam = EmptyStr;
	}
	return fnam;
}

//---------------------------------------------------------------------------
//t@CHTMLH
//---------------------------------------------------------------------------
bool isHtml(AnsiString fnam)
{
	if (fnam.AnsiPos("file:///")==1) fnam = get_local_name(fnam);
	AnsiString ext = ExtractFileExt(fnam).LowerCase();
	AnsiString HtmlExt = "|.htm|.html|.sht|.shtm|.shtml|.php|";
	return (HtmlExt.AnsiPos("|"+ext+"|")>0);
}

//---------------------------------------------------------------------------
//fnam ɃhCuȂ
//st@C̃fBNg̑΃t@Cɕς
//t@C݂Ȃ false Ԃ
//---------------------------------------------------------------------------
bool get_file_name_r(AnsiString &fnam)
{
	if (fnam.IsEmpty()) return false;
	if (ExtractFileDrive(fnam).IsEmpty())
		fnam = ExtractFilePath(Application->ExeName) + fnam;
	return FileExists(fnam);
}

//---------------------------------------------------------------------------
// TEdit 𐔎͂ł悤ɂ
//---------------------------------------------------------------------------
void set_ES_NUMBER(TEdit *ep)
{
	LONG style = ::GetWindowLong(ep->Handle, GWL_STYLE);
	::SetWindowLong(ep->Handle, GWL_STYLE, style | ES_NUMBER);
}
//---------------------------------------------------------------------------
// TUpDown Ɋ֘AÂĂҏW̒l`FbN
//---------------------------------------------------------------------------
bool check_TUpDown(TUpDown *udp)
{
	bool ret = true;
	if (udp->Associate) {
		char tbuf[256];
		::GetWindowText(udp->Associate->Handle, tbuf, sizeof(tbuf)-1);
		AnsiString tstr = tbuf;
		int n = tstr.ToIntDef(udp->Min-1);
		if ((n<udp->Min) || (n>udp->Max)) ret = false;
	}
	return ret;
}
//---------------------------------------------------------------------------
